"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatFile = void 0;
const prettier = require("prettier");
const formatFile = (content) => {
    return new Promise((res, rej) => prettier.resolveConfig(process.cwd()).then((options) => {
        if (!options) {
            // no prettier configuration was found -> do nothing
            res(content);
        }
        try {
            const formatted = prettier.format(content, Object.assign(Object.assign({}, options), { parser: 'typescript' }));
            res(formatted);
        }
        catch (error) {
            rej(error);
        }
    }));
};
exports.formatFile = formatFile;
//# sourceMappingURL=formatFile.js.map